
#
# backend-defs.mk
#
# macro definitions for compiling the parallel back-end
#

#
# T2 defines to be exported to the including makefile
#
T2_INCLUDES	= -I$(T2_DIR)/common/include \
		  -I$(T2_DIR)/back-end/include \
		  -I$(T2_DIR)/rtree
T2_LIBNAMES	= $(T2_DIR)/lib/libt2be.a
T2_LIBS		= $(T2_LIBNAMES)
T2_MAINOBJ	= $(T2_DIR)/lib/pbe.o


#
# include architecture-dependent definitions
#
include		$(T2_DIR)/arch/arch.mk
include		$(T2_DIR)/arch/$(T2_ARCHFILE)


#
# include compilation options provided by the users stored in T2_PBACKENDDEF,
# which should be defined in $(T2_DIR)/arch/$(T2_ARCHFILE);
# also define T2_PBACKEND for compiling the parallel back-end;
# define UNIX and LIBGIST for the R-tree code
#
T2_DEFINES	+= $(T2_PBACKENDDEF) -DT2_PBACKEND \
		   -DUNIX -DLIBGIST


#
# the set of makefiles included by this makefile;
# T2 code should be recompiled if any changes is made to one of these files,
# so the including makefile should make its .o files dependent on $(T2_MKFILES)
#
T2_MKFILES	= $(T2_DIR)/arch/arch.mk \
		  $(T2_DIR)/arch/mpi.mk $(T2_DIR)/arch/pvm.mk \
		  $(T2_DIR)/arch/meta-chaos.mk \
		  $(T2_DIR)/arch/$(T2_ARCHFILE)
