
#
# sbackend-defs.mk
#
# macro definitions for compiling the sequential back-end
#

#
# T2 defines to be exported to the including makefile
#
T2_INCLUDES	= -I$(T2_DIR)/common/include \
		  -I$(T2_DIR)/sback-end/include \
		  -I$(T2_DIR)/rtree
T2_LIBNAMES	= $(T2_DIR)/lib/libt2sbe.a
T2_LIBS		= $(T2_LIBNAMES)
T2_MAINOBJ	= $(T2_DIR)/lib/sbe.o


#
# include architecture-dependent definitions
#
include		$(T2_DIR)/arch/arch.mk
include		$(T2_DIR)/arch/seq-$(T2_ARCHFILE)


#
# include compilation options provided by the users stored in T2_SBACKENDDEF,
# which should be defined in $(T2_DIR)/arch/seq-$(T2_ARCHFILE);
# define UNIX and LIBGIST for the R-tree code
#
T2_DEFINES	+= $(T2_SBACKENDDEF) \
		   -DUNIX -DLIBGIST


#
# the set of makefiles included by this makefile;
# T2 code should be recompiled if any changes is made to one of these files,
# so the including makefile should make its .o files dependent on $(T2_MKFILES)
#
T2_MKFILES	= $(T2_DIR)/arch/arch.mk \
		  $(T2_DIR)/arch/seq-$(T2_ARCHFILE)
