
/* setup.C */

/*
 * Chialin Chang, chialin@cs.umd.edu, 6/10/98
 * system initialization for the parallel back-end server
 */


#include	"t2_header.h"
#include	"t2_signal.h"
#include	"t2_rts.h"


extern int _g_mynode;

void
t2_comm_setup(int& argc, char**& argv, char**& envp,
	      int& numnodes, int& mynode),
t2_comm_finalize();


////////////////////////////////////////////////////////////////////////
//
// setting up T2 back-end system
//
////////////////////////////////////////////////////////////////////////
void
t2_setup(int& argc, char**& argv, char**& envp, T2_RTS& rts)
{
  int numnodes;
  int mynode;

  t2_comm_setup(argc, argv, envp, numnodes, mynode);
  t2_Assert (numnodes > 0);
  t2_Assert (mynode >= 0);

  rts.setProcessorInfo(numnodes, mynode);

  // ignore SIGPIPE
  t2_signal(SIGPIPE, SIG_IGN);

  // for debugging purpose
  _g_mynode = mynode;
}



////////////////////////////////////////////////////////////////////////
//
// shutting down T2 back-end system
//
////////////////////////////////////////////////////////////////////////
void
t2_finalize()
{
  t2_comm_finalize();
}
