
/* t2_config.h */


#ifndef _T2_CONFIG_H_
#define _T2_CONFIG_H_



/*********************************************************************
 *
 * list of macros used by T2
 *
 *********************************************************************/

/*
 * T2_SYS_SUPPORT_IPV4 , T2_SYS_SUPPORT_IPV6
 *	defined		if os supports IPv4, IPv6, respectively
 *	undefined	otherwise
 */
#undef T2_SYS_SUPPORT_IPV4
#undef T2_SYS_SUPPORT_IPV6


/*
 * T2_SYS_SUPPORT_HSTRERROR
 *	defined		if os supports hstrerror()
 *	undefined	otherwise
 */
#undef	T2_SYS_SUPPORT_HSTRERROR


/*
 * T2_SYS_SUPPORT_INET_PTON, T2_SYS_SUPPORT_INET_NTOP
 *	defined		if os supports inet_pton(), inet_ntop(), respectively
 *	undefined	otherwise
 */
#undef	T2_SYS_SUPPORT_INET_PTON
#undef	T2_SYS_SUPPORT_INET_NTOP


/*
 * T2_SYS_SUPPORT_SOCKLEN_T
 *	defined		if os defines data type socklen_t
 *	undefined	otherwise
 */
#undef T2_SYS_SUPPORT_SOCKLEN_T




/*********************************************************************
 *
 * define appropriate macros as needed
 *
 *********************************************************************/

/* T2_SYS_SUPPORT_IPV4, T2_SYS_SUPPORT_IPV6 */
#if defined(SUNOS4) || defined(SUNOS5) || defined(AIX)
    #define	T2_SYS_SUPPORT_IPV4
#endif


/* T2_SYS_SUPPORT_HSTRERROR */
#if defined(SUNOS4) || defined(SUNOS5)
    #define	T2_SYS_SUPPORT_HSTRERROR
#endif


/* T2_SYS_SUPPORT_INET_PTON, T2_SYS_SUPPORT_INET_NTOP */
#ifdef T2_SYS_SUPPORT_IPV6
    #define	T2_SYS_SUPPORT_INET_PTON
    #define	T2_SYS_SUPPORT_INET_NTOP
#endif


/* T2_SYS_SUPPORT_SOCKLEN_T */
#ifdef T2_SYS_SUPPORT_IPV6
   #define	T2_SYS_SUPPORT_SOCKLEN_T
#endif




#endif	/* ! _T2_CONFIG_H_ */
