
/* $Id: t2_defs.h,v 1.5 2000/02/04 00:18:26 chialin Exp $ */

/* t2_defs.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 5/8/98
 * some T2 definitions
 */


#ifndef _T2_DEFS_H_
#define _T2_DEFS_H_


/* typedef for the processor id numbers */
/* typedef u_int T2_ProcID; */
typedef int T2_ProcID;			/* -1 can be used for special purpose */
#define T2_InvalidProcID	-1	/* can be used for special purpose */

/* typedef for T2 dataset ids */
typedef u_int T2_DSID;

/* typedef for T2 iterator ids */
typedef u_int T2_IteratorID;

/* typedef for the file ids of a T2 dataset */
typedef u_int T2_DSFileID;

/* typedef for the index ids */
typedef u_int T2_IndexID;

/* typedef for the chunk ids used by a T2 index */
typedef u_int T2_ChunkID;

/* typedef for the iteration numbers */
typedef u_int T2_Iteration;


#ifdef T2_SIMULATOR

/* typedef for data cluster id number */
typedef u_int T2SIM_DataClusterID;

/* typedef for strategy id number */
typedef u_int T2SIM_StrategyID;

#endif	/* T2_SIMULATOR */


/* return value for asynchronous (ie non-blocking) operations */
enum T2_AsyncResult { aSUCCEED=0, aFAIL_SYS, aFAIL_USR };


/* various types for user-defined functions (ie customization code) */
enum T2_UDFType { T2_UDF_Unknown = 0,
		  T2_UDF_Dataset, T2_UDF_Index,
		  T2_UDF_AccMeta, T2_UDF_Aggregation, T2_UDF_Projection,
		  T2_UDF_MetaChaos
};
#define T2_NUMBER_UDFTypes	7
#ifdef _ANSI_PROTO_
   T2_EXTERN_C
	enum T2_UDFType t2_shortstring2UDFType(const char* name);
   T2_EXTERN_C
	const char* t2_UDFType2string(enum T2_UDFType t);
   T2_EXTERN_C
	const char* t2_UDFType2shortstring(enum T2_UDFType t);
#else
   T2_EXTERN_C
	enum T2_UDFType t2_identifyUDFType();
   T2_EXTERN_C
	const char* t2_UDFType2string();
   T2_EXTERN_C
	const char* t2_UDFType2shortstring();
#endif



/* return value for user-defined functions (ie customization code) */
enum T2_UDFRet { T2_UDFRet_OK=0, T2_UDFRet_ERROR };



/* some definitions that allow T2 to use the bits inside an u_int */
#define T2_USHORT_BIT_0		1
#define T2_USHORT_BIT_1		2
#define T2_USHORT_BIT_2		4
#define T2_USHORT_BIT_3		8
#define T2_USHORT_BIT_4		16
#define T2_USHORT_BIT_5		32
#define T2_USHORT_BIT_6		64
#define T2_USHORT_BIT_7		128
#define T2_USHORT_BIT_8		256
#define T2_USHORT_BIT_9		512
#define T2_USHORT_BIT_10	1024



#endif	/* _T2_DEFS_H_ */
