
/* $Id: t2_endian.h,v 1.3 2000/03/16 00:47:24 chialin Exp $ */

/* t2_endian.h */

#ifndef __T2_ENDIAN_H_
#define __T2_ENDIAN_H_

#include	<stdio.h>

#define T2_UnknownEndian	0
#define T2_BigEndian		1
#define T2_LittleEndian		2


#ifdef __cplusplus
    extern "C" {
#endif

u_char t2_checkEndianess();

#ifdef _ANSI_PROTO_
    const char* endian2string(u_char c);
#else
    const char* endian2string();
#endif

#ifdef __cplusplus
    }
#endif


/* a function to swap bytes of a variable of a basic type for endian purposes
 * signature: t2_swapBytes((void *) v, size_t s)
 * arguments: v points to a variable of a basic type (int, long, double, ...),
 *	      l is the size of a basic type
 */
#define t2_swapBytes(v,l) \
		{ \
		   char *_bs, *_be; \
		   char _btemp; \
		   _bs = (char *) v; _be = ((char*)v)+l-1; \
		   while (_bs<_be) { \
		      _btemp = *_bs; *_bs = *_be; *_be = _btemp; \
		      _bs++; _be--; \
		   } \
		}

/* a function to swap bytes of an array of elements of a basic type 
 * for endian purposes
 * signature: t2_swapBytesArray((char *) a, size_t n, s)
 * arguments: a points to an array of elements of some basic type,
 *	      n is the number of elements in the array,
 *            s is the size of the basic type (int, long, double, ...)
 */
#define t2_swapBytesArray(a,n,s) \
		{ \
		   if (s > 1) { \
		      int _i; \
		      char *_as; \
		      _as = (char *) a; \
		      for (_i=0; _i<n; _i++) { \
		         t2_swapBytes(_as, s); \
		         _as += s; \
		      } \
		   } \
		}



#endif	/* ! __T2_ENDIAN_H_ */
