
/* $Id: t2_idrange.h,v 1.1 2000/02/04 00:18:26 chialin Exp $ */

/* t2_idrange.h */

#ifndef _T2_IDRANGE_H_
#define _T2_IDRANGE_H_

#include	"t2_header.h"


///////////////////////////////////////////////////////////////////////////
//
// T2_IDRange
//
// A range of id's.
//
///////////////////////////////////////////////////////////////////////////
class T2_IDRange {
public:
  int id_low, id_high;

  T2_IDRange(): id_low(0), id_high(0) {};
  ~T2_IDRange() {};

  T2_IDRange(const T2_IDRange& r): id_low(r.id_low), id_high(r.id_high) {};
  T2_IDRange& operator =(const T2_IDRange& r);

  // parse a string in the format "n-m" with no space in between 
  // and get the min and max of the range;
  // the results are either stored in id_low and id_high, or stored in
  // the given two int arguments;
  // note that this function would replace '-' with '\0'
  bool stringToRange(char* string);
  static bool stringToRange(char* string, int& min, int& max);

protected:
private:
};


inline T2_IDRange&
T2_IDRange::operator =(const T2_IDRange& r)
{
  id_low = r.id_low;
  id_high = r.id_high;
  return *this;
}

inline bool
T2_IDRange::stringToRange(char* string)
{
  return stringToRange(string, id_low, id_high);
}



#endif	/* ! _T2_IDRANGE_H_ */
