
/* t2_template.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 12/23/97
 * C++ templates used by T2.
 * Adapted from the part of Titan code written by Carter T. Shock.
 */

#ifndef _T2_TEMPLATE_H_
#define _T2_TEMPLATE_H_

#include	"t2_header.h"


///////////////////////////////////////////////////
//
// template functions
//
///////////////////////////////////////////////////
template<class Type>
inline bool
t2_between(const Type &A, const Type &B, const Type &C)
{
  return ((A <= B) && (C >= B)) ? true : false;
}

template<class Type>
inline Type
t2_max(const Type &A, const Type &B)
{
  return (A > B) ? A : B;
}

template<class Type>
inline Type
t2_min(const Type &A, const Type &B)
{
  return (A < B) ? A : B;
}

inline bool
t2_same_signs(long a, long b )
{
  return (((long) ((unsigned long) a ^ (unsigned long) b)) >= 0 )? true : false;
}

inline bool
t2_same_signs(const double &a, const double &b )
{
  return (((a >= 0.0) && (b >= 0.0)) || ((a < 0.0) && (b < 0.0)))? true : false;
}


#endif	/* _T2_TEMPLATE_H_ */

