
/* $Id: idrange.C,v 1.1 2000/02/04 00:18:45 chialin Exp $ */

/* idrange.C */

#include	<stdlib.h>
#include	<ctype.h>
#include	"t2_idrange.h"

/////////////////////////////////////////////////////////////////////////////
//
// T2_NameIDRangePair methods
//
/////////////////////////////////////////////////////////////////////////////
bool
T2_IDRange::stringToRange(char* string, int& min, int& max)
{
  if (string == NULL)
     return false;

  // a valid range has the format of 'n', '-n', and 'n-m' 
  // where n and m are non-negative numbers

  // look for '-', if any
  char* hyphen = string;
  bool digit_before_hyphen = false;
  while (*hyphen != '\0' && *hyphen != '-') {
    if (isdigit(*hyphen) == 0)	// not a number !!
       return false;
    digit_before_hyphen = true;
    hyphen++;
  }
  if (*hyphen == '\0') {	// no '-', so just a single positive number
     min = atoi(string);
     max = min;
     return true;
  }

  if (digit_before_hyphen == false) {	// no digit before hyphen, so assume -n
     min = atoi(string);
     max = min;
     return true;
  }

  // *hyphen == '-', so assume format n-m, and make sure that m >= n
  *hyphen = '\0';
  min = atoi(string);
  max = atoi(hyphen+1);
  *hyphen = '-';
  if (min > max)
     return false;
  return true;
}

