
/* feqpool.C */


#include	"t2_feqpool.h"


/////////////////////////////////////////////////////////////////////////////
//
// T2_FEQPool methods
//
/////////////////////////////////////////////////////////////////////////////
bool
T2_FEQPool::submitQuerySpec(T2_QSpec* q, T2_QSpecStatus* s)
{
  if (q == NULL || s == NULL)
     return false;

  if (isFull()) {
     t2_err_ret(__FILE__, __LINE__, "T2_FEQPool is full");
     return false;
  }

  t2_Assert (s->test() != 0);
  s->setStatus(t2_qsPending);
  return pool.enqueue(T2_QSpecStatusEntry(q, s));
}


bool
T2_FEQPool::retrieveQuerySpec(T2_QSpec*& q, T2_QSpecStatus*& s)
{
  if (isEmpty())
     return false;

  T2_QSpecStatusEntry e = pool.dequeue();
  q = e.qspec;
  s = e.status;
  return true;
}


bool
T2_FEQPool::cancelQuerySpec(T2_QSpecStatus* s)
{
  int i = searchQuerySpec(s);
  if (i < 0)
     return false;

  // ugly cast ...
  T2_QSpecStatusEntry& e = (T2_QSpecStatusEntry &) pool[i];
  t2_Assert (e.status->test() == 0);
  e.status->setStatus(t2_qsInactive);
  return true;
}


int
T2_FEQPool::searchQuerySpec(T2_QSpecStatus* s) const
{
  if (s == NULL || s->test() != 0)
     return -1;

  for (u_int i=0; i<getNumberElements(); i++) {
     if (pool[i].status == s)
	return i;
  }
  return -1;
}
