/*
  File name: hilbert_map.h

  $Id: hilbert_map.h,v 1.1 1999/02/01 22:48:36 kurc Exp $
*/
#ifndef HILBERT_MAP_H
#define HILBERT_MAP_H

typedef struct {
  unsigned int pnt_idx; /* order in the point array                 */
  unsigned int hsf_idx; /* order in the hilbert space filling curve */
                        /* it is also used to find the assignments  */
                        /* disks */
} _thsf2d_order_short;

typedef struct {
  unsigned int pnt_idx;
  unsigned int v[2];
} _thsf2d_order;

typedef struct {
  unsigned int pnt_idx;
  unsigned int v[3];
} _thsf3d_order;

typedef struct {
  unsigned int pnt_idx;
  unsigned int v[4];
} _thsf4d_order;

#if defined(__cplusplus)
extern "C" { 
#endif 

int hsf2d_compare(const void *a, const void *b);
int hsf3d_compare(const void *a, const void *b);
int hsf4d_compare(const void *a, const void *b);

unsigned int hilbert2Dshort(unsigned short x, unsigned short y);
int hilbert2D(unsigned int x, unsigned int y, unsigned int hn[]);
int hilbert3D(unsigned int x, unsigned int y, unsigned int z, 
	      unsigned int hn[]);
int hilbert4D(unsigned int  x, unsigned int  y, unsigned int  z, 
	      unsigned int  w, unsigned int  hn[]);

#if defined(__cplusplus)
};
#endif 

#endif /* HILBERT_MAP_H */
