
/* $Id: t2dld_getclusters.h,v 1.3 1999/03/27 19:44:14 chialin Exp $ */

/* t2dld_getclusters.h */

#ifndef _T2DLD_GETCLUSTERS_H_
#define _T2DLD_GETCLUSTERS_H_

#include	"t2dld_base.h"

/////////////////////////////////////////////////////////////////////////////
//
// T2DLD_TapeClusterArray
//
/////////////////////////////////////////////////////////////////////////////
class T2DLD_TapeClusterArray {
public:
  T2DLD_TapeClusterArray(T2DLD_DataClusterArray& a): clusters(a) {};
  ~T2DLD_TapeClusterArray() {};

  // query methods
  u_int getNumberDataFiles() const { return clusters.getNumberDataFiles(); };
  u_int getNumberDataClusters() const
				{ return clusters.getNumberDataClusters(); };

  // access methods
  const T2DLD_DataCluster* operator[] (u_int i) const { return clusters[i]; };
  const char* getDataFileName(u_int i) const
				{ return clusters.getDataFileName(i); };

  // append a new data cluster pointer to the array
  T2DLD_TapeClusterArray& operator << (T2DLD_DataCluster* i);

  // output to ostream
  ostream& write(ostream& os) const;

protected:
  T2DLD_DataClusterArray& clusters;

private:
};


inline T2DLD_TapeClusterArray& 
T2DLD_TapeClusterArray::operator << (T2DLD_DataCluster* i)
{
  t2_Assert (i != NULL);
  clusters << i;
  return *this;
}


inline ostream&
operator << (ostream& os, const T2DLD_TapeClusterArray& a)
{
  return a.write(os);
}



/////////////////////////////////////////////////////////////////////////////
//
// T2DLD_GetClustersFuncObj
//
/////////////////////////////////////////////////////////////////////////////
class T2DLD_GetClustersFuncObj {
public:
  T2DLD_GetClustersFuncObj() {};
  virtual ~T2DLD_GetClustersFuncObj() {};

  // initialization;
  // argument index_file is the file that stores information
  // for all data clusters in the data subset;
  // return true if succeeds, false otherwise
  virtual bool init(const char* index_file) = 0;

  // get number of dimensions for bounding boxes
  virtual u_int getNumberDimensions() = 0;

  // get a set of data clusters
  virtual void getClusters(T2DLD_TapeClusterArray& c) = 0;

protected:
private:
};



#endif	/* ! _T2DLD_GETCLUSTERS_H_ */
