
/* $Id: t2dld_placement.h,v 1.3 1999/03/30 21:45:53 chialin Exp $ */

/* t2dld_placement.h */

#ifndef _T2DLD_PLACEMENT_H_
#define _T2DLD_PLACEMENT_H_

#include	"t2dld_header.h"
#include	"t2dld_base.h"
#include	"t2dld_mover.h"

/////////////////////////////////////////////////////////////////////////////
//
// T2DLD_PlacementFuncObj
//
/////////////////////////////////////////////////////////////////////////////
class T2DLD_PlacementFuncObj {
public:
  T2DLD_PlacementFuncObj() {};
  virtual ~T2DLD_PlacementFuncObj() {};

  // initialization;
  // argument ndims is the number of dimensions for all bounding boxes,
  // argument ndisks is the number of disks available for declustering;
  // return true if succeed, false otherwise
  virtual bool init(const u_int ndims, const u_int ndisks) = 0;

  // perform data declustering/clustering;
  // argument mover_instr is an array of ndisks T2DLD_MoverInstruction objects;
  // return true if succeed, false otherwise
  virtual bool placeClusters(const T2DLD_DataClusterArray& tclusters,
			     T2_Array<T2DLD_MoverInstruction>& mover_instr) = 0;

protected:
private:
};



#endif	/* ! _T2DLD_PLACEMENT_H_ */
