/*
  File name: mc_data.H

  Contains the class definition for user customization.
*/
#ifndef MC_DATA_H
#define MC_DATA_H

#include "responsable.h"
#include "mc_regions.H"
#include "mc_options.H"
#include "mc_liste.H"
#include "mc_system.H"
#include "mc_otherdata.H"

class MC_DataSender {
private:
  MC_Options opts;
public:
  MC_DataSender() { 
    opts.setWhereTo(ComputeOnReceiver);
    opts.setCommOpt(DoNotOptComm);
  };
  virtual ~MC_DataSender() { };

  virtual MC_SetOfRegions&  getSetOfRegions() = 0;
  virtual MC_Liste&         derefLocal(const MC_Region& rgn, 
				       int glbOffset) = 0;
  virtual MC_OtherProgData& otherProgData() = 0;
  virtual MC_Options&       getOptions() { return opts; };
};

class MC_DataReceiver {
private:
public:
  MC_DataReceiver() { };
  virtual ~MC_DataReceiver() { };

  virtual MC_SetOfRegions&  getSetOfRegions() = 0;
  virtual MC_Liste&         derefGlobal(MC_Liste&        liste_goffset, 
					MC_SetOfRegions& setOfRegion,
					MC_Server&       my_pgme) = 0;
  virtual MC_OtherProgData& otherProgData() = 0;
};

class MC_DataSame {
private:
public:
  MC_DataSame() { };
  virtual ~MC_DataSame() { };

  virtual MC_SetOfRegions&  getSetOfRegionsSender() = 0;
  virtual MC_SetOfRegions&  getSetOfRegionsReceiver() = 0;
  virtual MC_Liste&         derefLocal(const MC_Region& rgn, 
				       int glbOffset) = 0;
  virtual MC_Liste&         derefGlobal(MC_Liste&        liste_goffset, 
					MC_SetOfRegions& setOfRegion,
					MC_Server&       my_pgme) = 0;
  virtual MC_OtherProgData& otherProgData() = 0;
};
  
#endif /* MC_DATA_H */
