/*
 * File name: mc_wrapper.c 
 *
 * g++ complains about some MC functions. So, this file contains code to 
 * wrap these functions used in implementation of interface for T2.
 */
#ifndef MC_WRAPPER_C
#define MC_WRAPPER_C

#include "comm.h"
#include "zm.h"
#include "responsable.h"
#include "communication.h"

void MC_FreeListeZM(liste_s *l, void (*f)(ZM_s *zm));
void MC_FreeListeSD(liste_s *l, void (*f)(SD_s *zm));
void MC_FreePgme(pgme_s *prog);
void MC_SendListe(liste_s *liste, TID tid, TmsgTag msgTag, 
		  void (*pack)(ZM_s *zm));

void MC_FreeListeZM(liste_s *l, void (*f)(ZM_s *zm))
{
  FreeListe(l,f);
}

void MC_FreeListeSD(liste_s *l, void (*f)(SD_s *zm))
{
  FreeListe(l,f);
}

void MC_FreePgme(pgme_s *prog)
{
  if (prog==NULL) 
    return;
    
  free(prog->name);
  free(prog->tid);
  free(prog);
}

void MC_SendListe(liste_s *liste, TID tid, TmsgTag msgTag, 
		  void (*pack)(ZM_s *zm))
{
  SendListe(liste,tid,msgTag,pack);
}

#endif /* MC_WRAPPER_C */
