#ifndef __compute_schedule__
#define __compute_schedule__

#include "util.h"
#include "global.h"
#include "liste.h"
#include "regionX.h"
#include "pgme.h"
#include "schedule.h"


typedef enum {
  Sender,             /* not yet Valid */
  Receiver            /* not yet Valid */
} WhatAmI;

typedef enum {
  ComputeOnSender,      /* not yet Valid */
  ComputeOnReceiver,
  ComputeOnBothSide     /* not yet Valid */
} WhereToCompute;

typedef enum {
  OptComm,              /* not yet Valid */ 
  DoNotOptComm
} T_OptimiseComm;


#ifdef __cplusplus
  extern "C" {
#endif


void
ComputeSchedule
_AnsiC_((
	 pgme_s             *pgme,
	 DataRepresentation *DADsender,
	 setOfRegion_s      *setOfRegionSender,
         liste_s            *( *LocalDereference )(),
         DataRepresentation *DADreceiver,
	 setOfRegion_s      *setOfRegionReceiver,
	 liste_s            *(*GlobalDereference)(),
	 sched_s            **sched_send,
	 sched_s            **sched_recv
	 ));

sched_s *
ComputeScheduleForSender
_AnsiC_((
	 WhereToCompute      wtc               ,
	 pgme_s             *sender_pgme       ,
	 DataRepresentation *DAD               ,
	 setOfRegion_s      *setOfRegion       ,
	 pgme_s             *other_pgme        ,
	 liste_s *(    *ArrayDereferenceFct )(),
  	 int      (         *ResponsableFct )(),
	 void               *knownAboutOtherPgmeData,
	 T_OptimiseComm      optComm
	 ));

sched_s *
ComputeScheduleForReceiver
_AnsiC_((
	 WhereToCompute      wtc               ,
	 pgme_s             *receiver_pgme     ,
	 DataRepresentation *DAD               ,
	 setOfRegion_s      *setOfRegion       ,
	 pgme_s             *other_pgme        ,
	 liste_s *(    *ArrayDereferenceFct )(),
	 T_OptimiseComm      optComm
	 ));

sched_s *
ComputeGetScheduleForSender
_AnsiC_((
	 WhereToCompute      wtc               ,
	 pgme_s             *sender_pgme       ,
	 DataRepresentation *DAD               ,
	 pgme_s             *other_pgme        ,
	 liste_s *(    *ArrayDereferenceFct )(),
  	 int      (         *ResponsableFct )(),
	 T_OptimiseComm      optComm
	 ));

sched_s *
ComputeGetScheduleForReceiver
_AnsiC_((
	 WhereToCompute      wtc               ,
	 pgme_s             *receiver_pgme     ,
	 DataRepresentation *DAD               ,
	 setOfRegion_s      *mySetOfRegion     ,
	 pgme_s             *other_pgme        ,
	 setOfRegion_s      *OtherSetOfRegion  ,
	 liste_s *(    *ArrayDereferenceFct )(),
	 T_OptimiseComm      optComm
	 ));

void SetGlueOptOn();


#ifdef __cplusplus
  }
#endif


#endif






