
#ifndef __region_X__
#define __region_X__

#include "util.h" 

typedef enum {R_Enum,R_HPF,R_Unkown}      T_RegionType         ;
#define number_of_region_type  3
typedef enum {R_replicated,R_distributed,R_local} T_RegionDistribution ;
typedef enum {Mem_Copy, Mem_Pointer}      T_MemOp              ;

/* 
 * Enumerate Region : each coordinate is specified individually
 * HPF region       : It is a region defined by [begin:end:stride]
 * 
 */

typedef struct{
  T_RegionType          type;
  T_RegionDistribution  distribution;
  T_MemOp               mem_type;
  int                   size;
} region_s;



#ifdef __cplusplus
  extern "C" {
#endif


region_s *Alloc_R_Enum  
_AnsiC_((
	 int  NumElem,
	 int *globalCoord,
	 T_RegionDistribution distribution,
	 T_MemOp                 mem_type
	 ));

region_s *Alloc_R_HPF
_AnsiC_((
	 int nbDim,
	 int *left,
	 int *right,
	 int *stride,
	 T_RegionDistribution distribution,
	 T_MemOp                 mem_type
	 ));

region_s *Alloc_R_Unkown
_AnsiC_((
	 void
	 ));

void Free_Region
_AnsiC_((
	 region_s *region
	 ));

void getRegionName
_AnsiC_((
	 region_s *region,
	 char *name
	 ));


#ifdef __cplusplus
  }
#endif


#define sizeRegion(region) (region->size)

/* ========================================================================= */

typedef struct{
  int        NumRegion;
  region_s  **regions  ;
  int       *BeginGlobalOffset;
} setOfRegion_s;



#ifdef __cplusplus
  extern "C" {
#endif


setOfRegion_s *Alloc_setOfRegion
_AnsiC_((
	 void
	 ));

setOfRegion_s *Add_Region_setOfRegion
_AnsiC_((
	 region_s      *region,
	 setOfRegion_s *setOfRegion
	 ));


/* ----------------------------------------------- New fct 21 Sept 1995 */
setOfRegion_s *
Add_LocalRegion_setOfRegion
_AnsiC_((
	 region_s      *region,
	 setOfRegion_s *setOfRegion,
	 int            Goffset
	 ));
/* -------------------------------------------------------------------- */

void Free_setOfRegion
_AnsiC_((
	 setOfRegion_s *setOfRegion
	 ));

void Print_setOfRegion
_AnsiC_((
	 setOfRegion_s *setOfRegion
	 ));

int SizeSetOfRegion
_AnsiC_((
	 setOfRegion_s *setOfRegion
	 ));


int NbRegionSetOfRegion
_AnsiC_((
	 setOfRegion_s *setOfRegion
	 ));

/*
void 
LastLocalRegionAddedToSetOfRegion
_AnsiC_((
	 setOfRegion_s *setOfRegion
	 ));
*/	
 

#ifdef __cplusplus
  }
#endif


/* ========================================================================= */

#endif






