#ifndef __schedule__
#define __schedule__

#include "util.h"
#include "pgme.h"
#include "liste.h"

typedef struct OneSched_ {
  struct OneSched_ *next;
  int              offset;
  int              size;
} OneSched_s;

typedef struct {
  int           nproc;
  int          *size;
  OneSched_s   **sched;
} sched_s;



#ifdef __cplusplus
  extern "C" {
#endif


void 
sendSchedule
_AnsiC_((
	 sched_s **tab_sched_recv,
	 sched_s **tab_sched_send,
	 pgme_s *pgme_recv,
	 pgme_s *pgme_send
	 ));

sched_s *
ReceiveSchedule
_AnsiC_((
	 pgme_s *pgme1
	 ));

void
computeScheduleForSendAndRecv
_AnsiC_((
	 sched_s **tab_sched_recv,
	 sched_s **tab_sched_send,
	 liste_s *liste_sd,
	 pgme_s  *pgme_recv,
	 pgme_s  *pgme_send
	 ));

sched_s *CreateSched
_AnsiC_((
	 int nproc
	 ));

sched_s *
AddSched
_AnsiC_((
	 sched_s *sched,
	 int proc,
	 int offset,
	 int size
	 ));

void FreeSched
_AnsiC_((
	 sched_s *sched
	 ));

void 
PrintSched
_AnsiC_((
	 sched_s *sched
	 ));


void sendScheduleLocal
_AnsiC_((
     sched_s **tab_sched_recv,
     sched_s **tab_sched_send,
     pgme_s *pgme,
     sched_s **sched_send,
     sched_s **sched_recv
	 ));


#ifdef __cplusplus
  }
#endif



#endif
