
#include "communication.h"
#include "pvm3.h"

void pvm_pack_ZM(zm)
ZM_s *zm;
{
  _affirmation_ (( " [pvm_pack_zm] zm!= NULL",zm!= NULL));
 if (zm!=NULL)
   pvm_pkint((int *)zm,4,1);
 _dprint_ ((" packZM "));
}

ZM_s *pvm_unpack_ZM(zm)
ZM_s *zm;
{
 if (zm==NULL)
   zm=alloc_ZM();
 pvm_upkint((int *)zm,4,1);
 _dprint_ ((" UnpackZM "));
 return(zm);
}
 
void SendListe(
	       liste,
	       tid,
	       msgTag,
	       pack)
liste_s   *liste;
TID       tid;
TmsgTag   msgTag;
void (*pack)(ZM_s*);
{ 
  _dprint_ (( "\n\nListe a envoyer a destination du noeud %i\n",tid));
  pvm_initsend(GlueEncoding);
  ApplyFctListe(liste,pack);
  pvm_send(tid,msgTag);
  _dprint_ (("Sending tag %i to node %i",msgTag,tid));
}

liste_s *
RecvListe(
	  tid,
	  tag,
	  unpack,
	  sizeOfUnpackedElement 
	  )
     TID       tid;
     TmsgTag   tag;
     ZM_s *(*unpack)(ZM_s*);
     int  sizeOfUnpackedElement;
{liste_s *liste=AllocListe();
 int bufid,i,iter;
 void *elem;
 int taille;

 bufid=pvm_recv(tid,tag);
 
 pvm_bufinfo(bufid,&taille,&tag,&tid);
 iter=taille/sizeOfUnpackedElement;
 
 for (i=0;i<iter;i++)
   {elem=(*unpack)(NULL);
    AddElemListe(liste,elem);
  }

 return(liste);
}

void SendSched(pgme,to,sched,tag)     
     pgme_s *pgme;
     int to;
     sched_s *sched;
     int tag;
{
  int proc;
  OneSched_s *Osched;

  pvm_initsend(GlueEncoding);
  pvm_pkint(&(sched->nproc),1,1);

#ifdef  _verbose_flag_on_
  printf("\n Sending to %i ",to);
  printf("(%i)",sched->nproc);
#endif
  for (proc=0;proc<sched->nproc;proc++)
    {      
      pvm_pkint(&(sched->size[proc]),1,1);
#ifdef  _verbose_flag_on_
  printf("%i",sched->size[proc]);
#endif      
      Osched=sched->sched[proc];
      while (Osched!=NULL)
	{
#ifdef  _verbose_flag_on_
	  printf("(%i,%i)",Osched->offset,Osched->size);
#endif
	  pvm_pkint(&(Osched->offset),1,1);
	  pvm_pkint(&(Osched->size),1,1);
	  Osched=Osched->next;
	}
    }
  pvm_send(TidPgme(pgme,to),tag);      
#ifdef  _verbose_flag_on_
  printf("\n");
#endif
}

sched_s *RecvSched(computesched_pgme,sched,tag)
     pgme_s *computesched_pgme;
     sched_s *sched;
     int tag;
{ 
  int i,j,proc;
  int MsgSizeInt,offset,size;
  int nproc;

  for (proc=0;proc<NumNodePgme(computesched_pgme);proc++)
    {  
      pvm_recv(TidPgme(computesched_pgme,proc),tag);
      pvm_upkint(&nproc,1,1);
      
      if (sched==NULL)
	sched=CreateSched(nproc);
      
      _affirmation_ (("nproc==sched->nproc",nproc==sched->nproc));

      for (i=0;i<nproc;i++)
	{
	  pvm_upkint(&MsgSizeInt,1,1);
	  for (j=0;j<MsgSizeInt;j++)
	    {pvm_upkint(&offset,1,1);
	     pvm_upkint(&size,1,1);
	     AddSched(sched,i,offset,size);
	   }
	}
    }
  return(sched);
}

void 
pvm_pack_SD(
	    sd)
     SD_s *sd;
{
  if (sd!=NULL)
    pvm_pkint((int *)sd,5,1);
  _dprint_ ((" packSD "));
}

SD_s *
pvm_unpack_SD(
	      sd)
     SD_s *sd;
{
  if (sd==NULL)
    sd=Malloc_s(SD_s);
  pvm_upkint((int *)sd,5,1);
  _dprint_ ((" UnpackSD "));
  return(sd);
}

void BroadcastSetOfRegion(setOfRegion,other_pgme)
	 setOfRegion_s *setOfRegion;
	 pgme_s *other_pgme;
{ int i;
  int tmp;
  if (MyPosMyPgme()==0)
    {
      pvm_initsend(GlueEncoding);
      pvm_pkint(&(setOfRegion->NumRegion),1,1);
      for (i=0;i<setOfRegion->NumRegion;i++)
	{
	  tmp=(setOfRegion->regions[i])->type;
	  pvm_pkint(&tmp,1,1);
       }
      for (i=0;i<NumNodePgme(other_pgme);i++)
	pvm_send(TidPgme(other_pgme,i),FLAG_Broadcast1);
      for (i=0;i<NbRegionSetOfRegion(setOfRegion);i++)
	BroadcastRegion(setOfRegion->regions[i],other_pgme);
    }
}

setOfRegion_s *RecvSetOfRegion(other_pgme)
     pgme_s *other_pgme;
{ int i;
  region_s *r;
  TID responsable;
  int NbRegion;
  T_RegionType *typeRegion;
  setOfRegion_s *setOfRegion=Alloc_setOfRegion();  

  _affirmation_(( "sizeof(T_RegionType)==sizeof(int)",sizeof(T_RegionType)==sizeof(int) ));

  responsable=TidPgme(other_pgme,0);
  pvm_recv(responsable,FLAG_Broadcast1);
  pvm_upkint(&NbRegion,1,1);
  typeRegion=(T_RegionType *)malloc(sizeof(T_RegionType)*NbRegion);
  for (i=0;i<NbRegion;i++)
    pvm_upkint((int *)typeRegion,NbRegion,1);
  for (i=0;i<NbRegion;i++)
    { r=NULL;
      switch (typeRegion[i]) {
      case R_Enum : 
	r=(region_s *)pvm_rcv_RegionEnum(responsable,FLAG_Broadcast2);
	Add_Region_setOfRegion(r,setOfRegion);
	break;
      case R_HPF:
	r=(region_s *)pvm_rcv_RegionHPF(responsable,FLAG_Broadcast2);
	Add_Region_setOfRegion(r,setOfRegion);
	break;
      case R_Unkown:
	NYI();
	break;
      default:
	warning("default unexpected");
	break;
      }
    }
  free(typeRegion); 
  typeRegion=NULL;

  return(setOfRegion);
}

void BroadcastRegion(region,other_pgme)
     region_s *region;
     pgme_s *other_pgme;
{int i;
 if (MyPosMyPgme()==0)   
   if (region!=NULL)
     {
       switch (region->type) {
       case R_Enum :
	 pvm_initsend(GlueEncoding);
	 pvm_pack_RegionEnum((region_enum_s *)region);
	 for (i=0;i<NumNodePgme(other_pgme);i++)
	   pvm_send(TidPgme(other_pgme,i),FLAG_Broadcast2);
	 break;
       case R_HPF:
	 pvm_initsend(GlueEncoding);
	 pvm_pack_RegionHPF((region_hpf_s *)region);
	 for (i=0;i<NumNodePgme(other_pgme);i++)
	   pvm_send(TidPgme(other_pgme,i),FLAG_Broadcast2);
	 break;
       case R_Unkown:
	 NYI();
	 break;
       default:
	 warning("default unexpected");
	 break;
	   }
     }
   else
     warning("\n Region = NULL ");     
}

void pvm_pack_RegionEnum(region)
region_enum_s *region;
{
  int tmp;
  tmp=region->type;          pvm_pkint(&tmp,1,1);
  tmp=region->distribution;  pvm_pkint(&tmp,1,1);
  tmp=region->mem_type;      pvm_pkint(&tmp,1,1);
  tmp=region->size;          pvm_pkint(&tmp,1,1);
  pvm_pkint(region->globalCoord,region->size,1);
}

region_enum_s *pvm_rcv_RegionEnum(tid,tag)
TID            tid;
TmsgTag        tag;
{
  int tmp;
  region_enum_s *region=Malloc_s(region_enum_s);

  pvm_recv(tid,tag);
  pvm_upkint(&(tmp),1,1); region->type=tmp;
  pvm_upkint(&(tmp),1,1); region->distribution=tmp;
  pvm_upkint(&(tmp),1,1); region->mem_type=Mem_Copy;
  pvm_upkint(&(region->size),1,1);
  region->globalCoord=(int *)malloc(sizeof(int)*region->size);
  pvm_upkint(region->globalCoord,region->size,1);
  return(region);
}

void pvm_pack_RegionHPF(region)
region_hpf_s *region;
{
  int tmp;
  tmp=region->type;          pvm_pkint(&tmp,1,1);
  tmp=region->distribution;  pvm_pkint(&tmp,1,1);
  tmp=region->mem_type;      pvm_pkint(&tmp,1,1);
  tmp=region->size;          pvm_pkint(&tmp,1,1);
  tmp=region->nbDim;         pvm_pkint(&tmp,1,1);
  pvm_pkint(region->left,region->nbDim,1);
  pvm_pkint(region->right,region->nbDim,1);
  pvm_pkint(region->stride,region->nbDim,1);
}

region_hpf_s *pvm_rcv_RegionHPF(tid,tag)
TID            tid;
TmsgTag        tag;
{
  int tmp;
  region_hpf_s *region=Malloc_s(region_hpf_s);
  pvm_recv(tid,tag);
  pvm_upkint(&(tmp),1,1); region->type=tmp;
  pvm_upkint(&(tmp),1,1); region->distribution=tmp;
  pvm_upkint(&(tmp),1,1); region->mem_type=Mem_Copy;
  pvm_upkint(&(region->size),1,1);
  pvm_upkint(&(region->nbDim),1,1);
  region->left=(int *)malloc(sizeof(int)*region->nbDim);
  region->right=(int *)malloc(sizeof(int)*region->nbDim);
  region->stride=(int *)malloc(sizeof(int)*region->nbDim);
  pvm_upkint(region->left,region->nbDim,1);
  pvm_upkint(region->right,region->nbDim,1);
  pvm_upkint(region->stride,region->nbDim,1);
  return(region);
}



