
#include <malloc.h>
#include <memory.h>
#include <stdio.h>

#include "util.h"
#include "liste.h"

liste_s *AllocListe()
{liste_s *liste;
 liste=(liste_s *)malloc(sizeof(liste_s));
 liste->premier=NULL;
 liste->dernier=NULL;
 liste->nbElem =0   ;
 return(liste);
}

MListe_s *AllocMListe()
{ MListe_s *membre=(MListe_s *)malloc(sizeof(MListe_s));
  membre->suiv=NULL;
  membre->elem=NULL;
  return(membre);
}

TListe_s *AllocTListe()
{
return(AllocListe());
}

void FreeListe(liste,FreeElem)
     liste_s *liste;       
     void (*FreeElem)();   
{
  MListe_s *membre;
  MListe_s *nextMembre;

  _affirmation_ (( "liste!=NULL", liste!=NULL ));
  membre=PremierListe(liste);
  while (membre!=NULL)
    { (*FreeElem)(ElemListe(membre));
      nextMembre=MSuivListe(membre);
      FreeMListe(membre);
      membre=nextMembre;
    }
  FreeTListe(liste);
}

void FreeTListe(liste)
     TListe_s *liste;
{
  liste->premier=NULL;
  liste->dernier=NULL;
  liste->nbElem =0   ;
  Free(liste);
}

void FreeMListe(membre)
     MListe_s *membre;
{
  membre->suiv=NULL;
  membre->elem=NULL;
  Free(membre);
}

void AddElemListe(liste,elem)
     liste_s *liste;
     void    *elem ;
{MListe_s *m;
  _affirmation_(( "liste!=NULL",liste!=NULL));
 m=AllocMListe();
 AddElemListeUsingMListe(liste,m,elem);
}

void
AddElemListeUsingMListe(liste,membre,elem)
     liste_s  *liste;
     MListe_s *membre;
     void     *elem ;
{
  _affirmation_(( "liste!=NULL",liste!=NULL));
  _affirmation_(( "membre!=NULL",membre!=NULL));
  _affirmation_(( "elem!=NULL",elem!=NULL));
  membre->suiv=NULL;
  if (liste->nbElem==0)
    liste->premier=membre;
  else
    liste->dernier->suiv=membre;
  liste->dernier=membre;
  membre->elem=elem;
  (liste->nbElem)++;
}

int NbElemListe(liste)
     liste_s  *liste;
{
_affirmation_(("liste!=NULL",liste!=NULL));
_affirmation_(("liste->nbElem>=0",liste->nbElem>=0));
return(liste->nbElem);
}
     

MListe_s *PremierListe(liste)
liste_s *liste;
{
  _affirmation_(("liste!=NULL",liste!=NULL));
  return(liste->premier);
}

MListe_s *DernierListe(liste)
     liste_s  *liste;
{
  _affirmation_(("liste!=NULL",liste!=NULL));
  return(liste->dernier);
}

EListe_s *MSuivListe(membre)
	 MListe_s  *membre;
{
  _affirmation_(("membre!=NULL",membre!=NULL));
  return(membre->suiv);
}

EListe_s *ElemListe(membre)
	 MListe_s  *membre;
{
  _affirmation_(("membre!=NULL",membre!=NULL));
  return(membre->elem);
}

liste_s *MoveListe(res,phagociter)
     liste_s *res;         
     liste_s *phagociter;
{
  _affirmation_(("res!=NULL",res!=NULL));
  _affirmation_(("phagociter!=NULL",phagociter!=NULL));
  if (res->premier==NULL)
    {/* pas d elements dans res */
      memcpy(res,phagociter,sizeof(TListe_s));
    }
  else
  if (phagociter->premier!=NULL)
    {
      res->dernier->suiv=phagociter->premier;
      res->dernier=phagociter->dernier;
      res->nbElem+=phagociter->nbElem;
    }
  FreeTListe(phagociter);
  return(res);
}

void ApplyFctListe(liste,fct)
     liste_s *liste;
     void (*fct)();
{MListe_s *membre;
 if (liste==NULL)
   return;
 _affirmation_(("liste!=NULL",liste!=NULL));
 membre=PremierListe (liste);
 while (membre!=NULL)
   {(*fct)(ElemListe(membre));
    membre=MSuivListe(membre);
   }
}

void PrintListe(liste,fct)
     liste_s *liste;
     void (*fct)();
{_affirmation_(("liste!=NULL",liste!=NULL));
#ifdef _verbose_flag_on_
 fprintf(stderr,"\n\nPrint Liste (nbElem=%i)\n",NbElemListe (liste));
#endif 
 ApplyFctListe(liste,fct);
#ifdef _verbose_flag_on_
 fprintf(stderr,"\ntnirP\n");
#endif 
}



