
#include "requete.h"
#include "util.h"
#include "pgme.h"
#include "liste.h"
#include "regionX.h"
#include "global.h"
#include "communication.h"
#include "zm.h"
#include "sd.h"
#include "boolean.h"

void 
traitement_requete_locale(
			  liste_of_zm   ,
			  DAD           ,
			  setOfRegion   ,
			  pgme          ,
			  DereferenceFct,
			  sched_send    ,
			  sched_recv
			  )
     liste_s            *liste_of_zm  ;
     DataRepresentation *DAD          ;
     setOfRegion_s      *setOfRegion  ;
     pgme_s             *pgme         ;
     liste_s     *(*DereferenceFct )();
     sched_s     **sched_send         ;
     sched_s     **sched_recv         ;
{ int i;
  sched_s **tab_sched_send;
  sched_s **tab_sched_recv;
  liste_s *liste_zm2=(*DereferenceFct)(liste_of_zm,
				       setOfRegion,
				       DAD,
				       pgme);
  liste_s *liste_sd;

  compress_liste_zm(liste_zm2);
  
  liste_sd=combineListeZM2SD(liste_zm2,
			     liste_of_zm);
  FreeListe(liste_of_zm,free_ZM);
  FreeListe(liste_zm2,free_ZM);

  tab_sched_recv=(sched_s **)
    malloc(sizeof(sched_s *)*NumNodePgme(pgme));
  for (i=0;i<NumNodePgme(pgme);i++)
      tab_sched_recv[i]=CreateSched(NumNodePgme(pgme)); 

  tab_sched_send=(sched_s **)
    malloc(sizeof(sched_s *)*NumNodePgme(pgme));
  for (i=0;i<NumNodePgme(pgme);i++)
      tab_sched_send[i]=CreateSched(NumNodePgme(pgme)); 

  computeScheduleForSendAndRecv(tab_sched_recv,
				tab_sched_send,
				liste_sd,
				pgme,
				pgme);
  FreeListe(liste_sd,free_SD);

  sendScheduleLocal(tab_sched_recv,
		    tab_sched_send,
		    pgme,
		    sched_send,
		    sched_recv);

  for (i=0;i<NumNodePgme(pgme);i++)
    FreeSched(tab_sched_recv[i]);
  for (i=0;i<NumNodePgme(pgme);i++)
      FreeSched(tab_sched_send[i]);
  Free(tab_sched_recv);
  Free(tab_sched_send);
}




void 
emission_requete(
		 liste_of_zm,
		 setOfRegion,
		 other_pgme,
		 ResponsableFct,
		 knownAboutOtherPgmeData
		 )
     liste_s       *liste_of_zm;
     setOfRegion_s *setOfRegion;
     pgme_s        *other_pgme ;
     int   (*ResponsableFct )();
     void *knownAboutOtherPgmeData;
{
  membre_liste_s  *l=PremierListe(liste_of_zm);
  liste_s        **tabListeZM;
  ZM_s            *zm;
  ZM_s            *ptZm;
  membre_liste_s  *ptMembreAUtiliser;
  int zmSize, zmGlobalOffset, zmProc, zmOffset, zmUsed;
  int ouTzmSize, RespProc;
  boolean fin=false;
  int i;

  if (l==NULL)
    {
      for (i=0;i<NumNodePgme(other_pgme);i++)
	SendListe(NULL,TidPgme(other_pgme,i),FLAG_REQUETE,
		  pvm_pack_ZM);
      return;
    }

  tabListeZM=
    (liste_s **)malloc(sizeof(liste_s *)*
		       NumNodePgme(other_pgme)
		       );
  for (i=0;i<NumNodePgme(other_pgme);i++)
    tabListeZM[i]=AllocListe();

  zm             = (ZM_s *)l->elem ;
  zmSize         = zm->size  ;
  zmGlobalOffset = zm-> globalOffset;
  zmProc         = zm->proc;
  zmOffset       = zm->offset;
  zmUsed         = 0;
  fin            = false;
  _affirmation_(( "zmSize!=0", zmSize!=0 ));
  while (fin!=true)
    { if (zmSize==0)
	{zm            = (ZM_s *)l->elem;
	 zmSize        = zm->size;
	 zmGlobalOffset= zm->globalOffset;
	 zmProc        = zm->proc;
	 zmOffset      = zm->offset;
	 zmUsed        = 0;
        }
      RespProc=(*ResponsableFct)(other_pgme,knownAboutOtherPgmeData,
				 zmGlobalOffset,zmSize,
				 &ouTzmSize);
      if (zmUsed==0)
	{ptZm=zm;
	 ptMembreAUtiliser=l;
	 l=MSuivListe(l);
	 zmUsed++;
       }
      else
	{ptZm=alloc_ZM();
	 ptMembreAUtiliser=AllocMListe();
       }

      set_ZM(ptZm,
	     zmGlobalOffset,zmProc,zmOffset,ouTzmSize);
      AddElemListeUsingMListe(
			      tabListeZM[RespProc],
			      ptMembreAUtiliser,
			      ptZm);

      zmSize         -= ouTzmSize;
      zmGlobalOffset += ouTzmSize;
      /* 
	 glouups boggus 
	 debut des modifications 
	 Fri Nov  3 18:11:17 EST 1995	 
	 */
      zmOffset       += ouTzmSize;
      if (zmSize==0 && l==NULL)
	fin=true;
    }



  for (i=0;i<NumNodePgme(other_pgme);i++)
    {
      SendListe(tabListeZM[i],TidPgme(other_pgme,i),FLAG_REQUETE,
	      pvm_pack_ZM);
    }
  
  for (i=0;i<NumNodePgme(other_pgme);i++)
    FreeListe(tabListeZM[i],free_ZM);

  FreeTListe(liste_of_zm);
  Free(tabListeZM);

}

liste_s * 
reception_requete(
		  other_pgme
		  )
     pgme_s *other_pgme;
{liste_s *liste_of_zm;
 liste_s *tmp_liste_of_zm;
 int i;

 liste_of_zm=AllocListe();
 for (i=0;i<other_pgme->nbNode;i++)
   {
     tmp_liste_of_zm=
       RecvListe(TidPgme(other_pgme,i),FLAG_REQUETE,
		 pvm_unpack_ZM,sizeof(ZM_s));
     MoveListe(liste_of_zm,tmp_liste_of_zm);
   }

 return(liste_of_zm);
}

void 
traitement_requete(
		   liste_of_zm   ,
		   DAD           ,
		   setOfRegion   ,
		   receiver_pgme , /* ici receiver is my_pgme */
		   sender_pgme    ,
		   DereferenceFct,
		   optComm
		   )
     liste_s            *liste_of_zm  ;
     DataRepresentation *DAD          ;
     setOfRegion_s      *setOfRegion  ;
     pgme_s             *receiver_pgme;
     pgme_s             *sender_pgme   ;
     liste_s     *(*DereferenceFct )();
     T_OptimiseComm      optComm      ;
{ int i;
  sched_s **tab_sched_send;
  sched_s **tab_sched_recv;
  liste_s *liste_zm2=(*DereferenceFct)(liste_of_zm,
				       setOfRegion,
				       DAD,
				       receiver_pgme);
  liste_s *liste_sd;

#ifdef _verbose_flag_on_
  PrintListe(liste_of_zm,print1_ZM);
  PrintListe(liste_zm2  ,print1_ZM);
#endif

  compress_liste_zm(liste_zm2);

  liste_sd=combineListeZM2SD(liste_zm2,
			     liste_of_zm);
#ifdef _verbose_flag_on_
  PrintListe(liste_sd,print1_SD);
#endif

  FreeListe(liste_of_zm,free_ZM);
  FreeListe(liste_zm2,free_ZM);

  tab_sched_recv=(sched_s **)
    malloc(sizeof(sched_s *)*NumNodePgme(receiver_pgme));

  for (i=0;i<NumNodePgme(receiver_pgme);i++)
      tab_sched_recv[i]=CreateSched(NumNodePgme(sender_pgme)); 

  tab_sched_send=(sched_s **)
    malloc(sizeof(sched_s *)*NumNodePgme(sender_pgme));

  for (i=0;i<NumNodePgme(sender_pgme);i++)
      tab_sched_send[i]=CreateSched(NumNodePgme(receiver_pgme)); 

  computeScheduleForSendAndRecv(tab_sched_recv,
				tab_sched_send,
				liste_sd,
				receiver_pgme,
				sender_pgme);
  FreeListe(liste_sd,free_SD);

  sendSchedule(tab_sched_recv,
	       tab_sched_send,
	       receiver_pgme,
	       sender_pgme);

  for (i=0;i<NumNodePgme(receiver_pgme);i++)
      FreeSched(tab_sched_recv[i]);
  for (i=0;i<NumNodePgme(sender_pgme);i++)
      FreeSched(tab_sched_send[i]);
  Free(tab_sched_recv);
  Free(tab_sched_send);
}

liste_s *combineListeZM2SD(liste1,liste2)
liste_s *liste1;
liste_s *liste2;
{
  liste_s *ll;
  MListe_s *noeud1, *noeud2;
  int size1,size2;
  int offset1,offset2;
  SD_s *sd;

  ll=AllocListe();

  noeud1=PremierListe(liste1);
  noeud2=PremierListe(liste2);

  if (noeud1==NULL && noeud2==NULL) return(ll);
  if (noeud1==NULL && noeud2!=NULL) noeud1=noeud2;
  if (noeud2==NULL && noeud1!=NULL) noeud2=noeud1;

  size1=size_ZM(noeud1->elem);
  size2=size_ZM(noeud2->elem);
  offset1=offset_ZM(noeud1->elem);
  offset2=offset_ZM(noeud2->elem);

  while (noeud1!=NULL)
    {
      if (size1==size2)
	{
	  sd=init_SD(proc_ZM(noeud1->elem),offset1,
		     proc_ZM(noeud2->elem),offset2,
		     size1);
	  AddElemListe(ll,sd);
	  size1=0;
	  size2=0;
	}
      else if (size1>size2)
	{
	  sd=init_SD(proc_ZM(noeud1->elem),offset1,
		     proc_ZM(noeud2->elem),offset2,
		     size2);
	  AddElemListe(ll,sd);
	  offset1=offset1+size2;
	  size1=size1-size2;
	  size2=0;
	}
      else if (size1<size2)
	{
	  sd=init_SD(proc_ZM(noeud1->elem),offset1,
		     proc_ZM(noeud2->elem),offset2,
		     size1);
	  AddElemListe(ll,sd);
	  offset2=offset2+size1;
	  size2=size2-size1;
	  size1=0;
	}
      else 
	warning("Ouups");
      
      if (size1==0)
	{noeud1=noeud1->suiv;
	 if (noeud1!=NULL)
	   {size1=size_ZM(noeud1->elem);
	    offset1=offset_ZM(noeud1->elem);
	   }
       }
      
      if (size2==0)
	{noeud2=noeud2->suiv;
	 if (noeud2!=NULL)
	   {size2=size_ZM(noeud2->elem);
	    offset2=offset_ZM(noeud2->elem);
	  }
       }
      
      if (noeud1==NULL && noeud2!=NULL)
	warning("\n------> pb1 <---------\n");
      if (noeud2==NULL && noeud1!=NULL)
	warning("\n------> pb2 <---------\n");

    }

  return(ll);
}






