#include <sys/time.h>
/*
#ifndef SUN
#include <sys/timers.h>
#else
#include <sys/timer.h>
#endif
*/

#include <pvm3.h>
#include "util.h"
#include "pgme.h"


#define MAX_TIMER 20

int start_time[MAX_TIMER];
int add_time[MAX_TIMER]  ;

extern pgme_s *my_pgme__;

init_timers()
{
  int i;
  for (i=0;i<MAX_TIMER;i++)
    add_time[i]=0;
  for (i=0;i<MAX_TIMER;i++)
    start_time[i]=0;
#ifdef _verbose_flag_on_
  printf("\nWarning I have put a Synchronization before every start timer \n");
#endif 
}

start_timer(timer)
int timer;
{
  struct timeval tp;
  struct timezone tz;
  
  SyncPgme(my_pgme__);
  
  gettimeofday (&tp,&tz);
  start_time[timer] = tp.tv_sec * 1000000 + tp.tv_usec;
}

start_timer_1(timer)
int timer;
{
  struct timeval tp;
  struct timezone tz;
    
  gettimeofday (&tp,&tz);
  start_time[timer] = tp.tv_sec * 1000000 + tp.tv_usec;
}

stop_timer(timer)
int timer;
{
  struct timeval tp;
  struct timezone tz;

  gettimeofday (&tp,&tz);
  add_time[timer] += tp.tv_sec * 1000000 + tp.tv_usec - start_time[timer] ;
}

print_timer(timer)
int timer;
{
  write_timer(timer,stdout);
}

write_timer(timer,F)
int   timer;
FILE *F;
{
  fprintf(F," %i ",add_time[timer]/1000);
}

write_timer3(timer,F)
int timer;
FILE *F;
{
  fprintf(F," %i %i %i (ms) ",
	  return_timer_min(timer)/1000,
	  return_timer(timer)/1000,
	  return_timer_max(timer)/1000);	  
}

return_timer(timer)
int timer;
{
  return(add_time[timer]);
}

return_timer_max(timer)
int timer;
{
  int i,tmp,result;

  pvm_initsend(GlueEncoding);
  pvm_pkint(&(add_time[timer]),1,1);
  pvm_send(TidPgme(my_pgme__,0),1007);     
  if (MyPosPgme(my_pgme__)==0)
    {
      result=add_time[timer];
      for (i=0;i<NumNodePgme(my_pgme__);i++)
	{
	  pvm_recv(TidPgme(my_pgme__,i),1007);     
	  pvm_upkint(&tmp,1,1);
	  result=max(result,tmp);
	}
      for (i=0;i<NumNodePgme(my_pgme__);i++)
	{
	  pvm_initsend(GlueEncoding);
	  pvm_pkint(&(result),1,1);
	  for (i=0;i<NumNodePgme(my_pgme__);i++)
	    pvm_send(TidPgme(my_pgme__,i),1007);     
	}
    }
  pvm_recv(TidPgme(my_pgme__,0),1007);     
  pvm_upkint(&result,1,1);

  SyncPgme(my_pgme__);

  return(result);
}

return_timer_min(timer)
int timer;
{
  int i,tmp,result;

  pvm_initsend(GlueEncoding);
  pvm_pkint(&(add_time[timer]),1,1);
  pvm_send(TidPgme(my_pgme__,0),1008);     
  if (MyPosPgme(my_pgme__)==0)
    {
      result=add_time[timer];
      for (i=0;i<NumNodePgme(my_pgme__);i++)
	{
	  pvm_recv(TidPgme(my_pgme__,i),1008);     
	  pvm_upkint(&tmp,1,1);
	  result=min(result,tmp);
	}
      for (i=0;i<NumNodePgme(my_pgme__);i++)
	{
	  pvm_initsend(GlueEncoding);
	  pvm_pkint(&(result),1,1);
	  for (i=0;i<NumNodePgme(my_pgme__);i++)
	    pvm_send(TidPgme(my_pgme__,i),1008);     
	}
    }
  pvm_recv(TidPgme(my_pgme__,0),1008);     
  pvm_upkint(&result,1,1);

  SyncPgme(my_pgme__);

  return(result);
}



