#include <stdio.h>
#include "pvm3.h"

#include "util.h"
#include "pgme.h"
#include "schedule.h"


/* integer */

int iDataMoveSend(to,sched,tab,tag)
     pgme_s *to;
     sched_s *sched;
     int *tab;
     int tag;
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;

  if (sched==NULL) return(0);
  _affirmation_(("to->nbNode==sched->nproc",to->nbNode==sched->nproc));

  for (proc=0;proc<sched->nproc;proc++)
    { sendFlag=0;
      Osched=sched->sched[proc];
      if (Osched!=NULL)
	{
	  sendFlag=1;
	  pvm_initsend(GlueEncoding);
	}
      
      while (Osched!=NULL)
	{
#ifdef _verbose_flag_on_
	  {int ii;
	   for (ii=0;ii<Osched->size;ii++)
	     printf("<%i>",tab[Osched->offset+ii]);
	   for (ii=0;ii<Osched->size;ii++)
	     printf("[%i]",Osched->offset+ii);
	   printf("\n");
  	  }
#endif
	  pvm_pkint(tab+Osched->offset,Osched->size,1);
	  Osched=Osched->next;
	}     
      if (sendFlag==1)
	{
	  pvm_send(TidPgme(to,proc),tag);
	}
    }
  return(0);
}

int iDataMoveRecv(from,sched,tab,tag)
     pgme_s  *from;
     sched_s *sched;
     int *tab;
     int tag;
{  
  int proc;
  OneSched_s *Osched;

  if (sched==NULL) return(0);
  _affirmation_(("from->nbNode==sched->nproc",from->nbNode==sched->nproc));

  for (proc=0;proc<sched->nproc;proc++)
    {       
      Osched=sched->sched[proc];
      if  (Osched!=NULL)
	{pvm_recv(TidPgme(from,proc),tag);
	 while (Osched!=NULL)
	   {
#ifdef _verbose_flag_on_
	     printf("\n Received: ");
	     printf(" %i elem put %i ",Osched->size,Osched->offset);
#endif
	     pvm_upkint(tab+Osched->offset,Osched->size,1);
	     Osched=Osched->next;
	   }
       }
    }
  return(0);
}

  

/* float */

int fDataMoveSend(to,sched,tab,tag)
     pgme_s *to;
     sched_s *sched;
     float *tab;
     int tag;
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;

  if (sched==NULL) return(0);
  _affirmation_(("to->nbNode==sched->nproc",to->nbNode==sched->nproc));

  for (proc=0;proc<sched->nproc;proc++)
    { sendFlag=0;
      Osched=sched->sched[proc];
      if (Osched!=NULL)
	{
	  sendFlag=1;
	  pvm_initsend(GlueEncoding);
	}
      
      while (Osched!=NULL)
	{
	  pvm_pkfloat(tab+Osched->offset,Osched->size,1);
	  Osched=Osched->next;
	}     
      if (sendFlag==1)
	{
	  pvm_send(TidPgme(to,proc),tag);
	}
    }
  return(0);
}

int fDataMoveRecv(from,sched,tab,tag)
     pgme_s  *from;
     sched_s *sched;
     float *tab;
     int tag;
{  
  int proc;
  OneSched_s *Osched;

  if (sched==NULL) return(0);
  _affirmation_(("from->nbNode==sched->nproc",from->nbNode==sched->nproc));

  for (proc=0;proc<sched->nproc;proc++)
    {       
      Osched=sched->sched[proc];
      if  (Osched!=NULL)
	{pvm_recv(TidPgme(from,proc),tag);
	 while (Osched!=NULL)
	   {
	     pvm_upkfloat(tab+Osched->offset,Osched->size,1);
	     Osched=Osched->next;
	   }
       }
    }
  return(0);
}

/* double */

int dDataMoveSend(to,sched,tab,tag)
     pgme_s *to;
     sched_s *sched;
     double *tab;
     int tag;
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;

  if (sched==NULL) return(0);
  _affirmation_(("to->nbNode==sched->nproc",to->nbNode==sched->nproc));

  for (proc=0;proc<sched->nproc;proc++)
    { sendFlag=0;
      Osched=sched->sched[proc];
      if (Osched!=NULL)
	{
	  sendFlag=1;
	  pvm_initsend(GlueEncoding);
	}
      
      while (Osched!=NULL)
	{
/*	  pvm_pkdouble(tab+Osched->offset,Osched->size,1); */
	  pvm_pkbyte(tab+Osched->offset,Osched->size*sizeof(double),1);
	  Osched=Osched->next;
	}     
      if (sendFlag==1)
	{
	  pvm_send(TidPgme(to,proc),tag);
	}
    }
  return(0);
}

int dDataMoveRecv(from,sched,tab,tag)
     pgme_s  *from;
     sched_s *sched;
     double *tab;
     int tag;
{  
  int proc;
  OneSched_s *Osched;

  if (sched==NULL) return(0);
  _affirmation_(("from->nbNode==sched->nproc",from->nbNode==sched->nproc));

  for (proc=0;proc<sched->nproc;proc++)
    {       
      Osched=sched->sched[proc];
      if  (Osched!=NULL)
	{pvm_recv(TidPgme(from,proc),tag);
	 while (Osched!=NULL)
	   {
	     /*	     pvm_upkdouble(tab+Osched->offset,Osched->size,1); */
	     pvm_upkbyte(tab+Osched->offset,Osched->size*sizeof(double),1);
	     Osched=Osched->next;	    
	   }
       }
    }
  return(0);
}

  

