
/* $Id: w_gistfile.h,v 1.2 1999/03/27 19:37:10 chialin Exp $ */

/* w_gistfile.h */

#ifndef _W_GISTFILE_H_
#define _W_GISTFILE_H_


#include	"gist_file.h"


////////////////////////////////////////////////////////////////////////////
//
// W_GistFile
//
// This is just a wrapper class for gist_file. Here are the additional
// data members and methods added.
//	bool attached		set to true if the fileHandle was attached
//				to the class, in which case a close will
//				not be performed to the fileHandle 
//				at the end
//	rc_t attach(int fd)	instead of opening a file with a filename,
//				attach this class directly to a open
//				file descriptor
//
////////////////////////////////////////////////////////////////////////////
class W_GistFile: public gist_file {
public:
  W_GistFile(): gist_file(), attached(false) {};
  ~W_GistFile() { if(isOpen) close(); };

  // attach a file descriptor to the file;
  // this method is very similar to open, except that it takes a file 
  // descriptor, as opposed to a filename;
  rc_t attach(int fd);

  // flush and empty buffers
  rc_t close();

protected:
  bool attached;

private:
};



#endif	/* ! _W_GISTFILE_H_ */
