
/* t2_auxdata.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 5/14/98
 * a class derived from T2_UsrArg to hold user-define aux data
 */


#ifndef _T2_AUXDATA_H_
#define _T2_AUXDATA_H_


#include	"t2_header.h"
#include	"t2_usrarg.h"


///////////////////////////////////////////////////////////////////////////
//
// T2_AuxData
//
// A class derivef from T2_UsrArg to hold user-define aux data.
// This is needed as T2_UsrArg only allows one to allocate buffer
// for it when it reads from a file. T2_AuxData therefore allows
// callers (ie T2 functions, not user-functions) to allocate memory
// explicitly.
//
///////////////////////////////////////////////////////////////////////////
class T2_AuxData: public T2_UsrArg {
public:
  T2_AuxData(size_t s = 0);
  ~T2_AuxData() {};

  // query methods
  size_t getDataSize() const { return T2_UsrArg::getDataSize(); };
  size_t getBufferSize() const { return T2_UsrArg::getBufferSize(); };

  // throw away the old data and allocate new space of s bytes
  size_t allocBuffer(size_t s) { return T2_UsrArg::allocBuffer(s); };

protected:
private:
};


inline
T2_AuxData::T2_AuxData(size_t s): T2_UsrArg()
{
  T2_AuxData::allocBuffer(s);
}



#endif	/* _T2_AUXDATA_H_ */
