
/* t2_bbuf.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 5/12/98
 * buffer for a block request
 */


#ifndef _T2_BBUF_H_
#define _T2_BBUF_H_

#include	"t2_header.h"


//////////////////////////////////////////////////////////////////
//
// T2_BBuffer
//
//////////////////////////////////////////////////////////////////
class T2_BBuffer {
public:
  T2_BBuffer();
  T2_BBuffer(const T2_BBuffer&);
  ~T2_BBuffer();

  // operator =
  T2_BBuffer& operator =(const T2_BBuffer&);

  // const access methods
  const char* getBuffer() const { return buf; };
  size_t getBufferSize() const { return bufsize; };
  bool hasNoBuffer() const { return (buf == NULL)? true : false; };
//  operator void* () { return (buf == NULL)? 0 : this; };

  // non-const access methods
  char* getBuffer() { return buf; };
  size_t setBufferSize(size_t s) { return (bufsize = s); };

  // allocate/release buffer space
  size_t alloc(size_t n);
  void release();

protected:
  char *buf;
  size_t bufsize;
  
private:
};



#endif	/* _T2_BBUF_H_ */
