
/* $Id: read-dataset-register.C,v 1.2 2000/01/21 00:56:32 chialin Exp $ */

/* read-dataset-register.C */


#include	<unistd.h>
#include	<sys/types.h>
#include	<regex.h>
#include	"t2_header.h"
#include	"t2_dsreg.h"


//////////////////////////////////////////////////////////////////////////
//
// main program
//
//////////////////////////////////////////////////////////////////////////
main(int argc, char** argv)
{
  if (argc < 2) {
     cout << "Usage: " << argv[0]
	  << " <dataset register file> [<dataset register file> ...]"
	  << endl;
     return -1;
  }

  T2_DSRegistrationFileReader dsreg;
  for (int i=1; i<argc; i++) {
     // try to open the constructor catalog file
     dsreg.open(argv[i]);
     if (!dsreg) {
         cout << "ERROR: cannot open '" << argv[i] << "'" << endl;
         continue;
     }

     cout << "Reading file: " << argv[i] << " =============" << endl;;
     T2_DSRegistrationEntry e;
     while (dsreg.getNextEntry(e) == true) {
	cout << e;
	if (e.check_content_correct(128) == false) {
	   cout << "ERROR: This entry is invalid." << endl;
	}
	cout << endl;
     }

     cout << endl;
     dsreg.close();
  }
 
  return 0;
}

